# perplexity-dev-ti
API for generating chat completions using Perplexity's AI models

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.1
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import perplexity_dev_ti
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import perplexity_dev_ti
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import perplexity_dev_ti
from perplexity_dev_ti.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.perplexity.ai
# See configuration.py for a list of all supported configuration parameters.
configuration = perplexity_dev_ti.Configuration(
    host = "https://api.perplexity.ai"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): bearerAuth
configuration = perplexity_dev_ti.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with perplexity_dev_ti.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = perplexity_dev_ti.DefaultApi(api_client)
    chat_completion_request = perplexity_dev_ti.ChatCompletionRequest() # ChatCompletionRequest | 

    try:
        # Generate chat completion
        api_response = api_instance.create_chat_completion(chat_completion_request)
        print("The response of DefaultApi->create_chat_completion:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->create_chat_completion: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.perplexity.ai*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**create_chat_completion**](docs/DefaultApi.md#create_chat_completion) | **POST** /chat/completions | Generate chat completion


## Documentation For Models

 - [ChatCompletionRequest](docs/ChatCompletionRequest.md)
 - [ChatCompletionResponse](docs/ChatCompletionResponse.md)
 - [Choice](docs/Choice.md)
 - [ChoiceDelta](docs/ChoiceDelta.md)
 - [Message](docs/Message.md)
 - [Usage](docs/Usage.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (JWT)


## Author




